/*!
 * @file mover_trigger_delay_list.h
 *  A list to delay trigger-state-changes.
 */

#ifndef _MOVER_TRIGGER_DELAY_LIST_H
#define _MOVER_TRIGGER_DELAY_LIST_H


class MoverTriggerDelayListElement
{
    public:
        MoverTriggerDelayListElement(bool state, bool oldState, float time);
        ~MoverTriggerDelayListElement();
        
        bool state;
        bool oldState;
        float time;
        MoverTriggerDelayListElement *next;
};


class MoverTriggerDelayList
{
    public:
        MoverTriggerDelayList();
        ~MoverTriggerDelayList();

        void addState(bool state, bool oldState, float time);
        void deleteFirstState();
        MoverTriggerDelayListElement *getFirstState();
        MoverTriggerDelayListElement *getLastState();
        bool isEmpty();

    private:
        MoverTriggerDelayListElement *first;
};


#endif
