/*!
 * @file mover_trigger_event.h
 *  Gets triggered when a specific event occurs.
 */

#ifndef _MOVER_TRIGGER_EVENT_H
#define _MOVER_TRIGGER_EVENT_H

#include "mover_trigger.h"


class EventTrigger : public MoverTrigger
{
    ObjectListDeclaration(EventTrigger);

    public:
        EventTrigger(const TiXmlElement* root = NULL);
        virtual ~EventTrigger();
        virtual void loadParams(const TiXmlElement* root);
        void setEvent(const std::string& eventName) { this->eventName = eventName; }

    private:
        virtual bool checkIsTriggered();
        std::string                 eventName;
        MoverTriggerPointerList     *eventTriggers;
        bool                        bIsChecking;
};


#endif

