/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2007 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Fabian 'x3n' Landau
   co-programmer:
*/

#include "util/loading/load_param.h"
#include "util/loading/factory.h"
#include "mover_trigger_intervisibility.h"

ObjectListDefinition(IntervisibilityTrigger);
CREATE_FACTORY(IntervisibilityTrigger);


IntervisibilityTrigger::IntervisibilityTrigger(const TiXmlElement* root)
{
    this->registerObject(this, IntervisibilityTrigger::_objectList);
    this->toList(OM_ENVIRON);

    this->onlyHumans = false;
    this->onlyNPCs =  false;

    if (root != NULL)
        this->loadParams(root);

    this->init_post_params();
}

void IntervisibilityTrigger::loadParams(const TiXmlElement* root)
{
    MoverTrigger::loadParams(root);

    LoadParam(root, "onlyHumans", this, IntervisibilityTrigger, setOnlyHumans)
        .describe("Only human players can release the trigger.")
        .defaultValues(false);
    LoadParam(root, "onlyNPCs", this, IntervisibilityTrigger, setOnlyNPCs)
        .describe("Only NPCs can release the trigger.")
        .defaultValues(false);
}

bool IntervisibilityTrigger::checkIsTriggered()
{
    /* TODO */
    return false;
}
