/*!
 * @file mover_trigger_intervisibility.h
 *  Gets triggered when the trigger "sees" the player.
 */

#ifndef _MOVER_TRIGGER_INTERVISIBILITY_H
#define _MOVER_TRIGGER_INTERVISIBILITY_H

#include "mover_trigger.h"


class IntervisibilityTrigger : public MoverTrigger
{
    ObjectListDeclaration(IntervisibilityTrigger);

    public:
        IntervisibilityTrigger(const TiXmlElement* root = NULL);
        virtual void loadParams(const TiXmlElement* root);
        void setOnlyHumans(bool onlyHumans = true) { this->onlyHumans = onlyHumans; }
        void setOnlyNPCs(bool onlyNPCs = true) { this->onlyNPCs = onlyNPCs; }

    private:
        virtual bool checkIsTriggered();
        bool onlyHumans;
        bool onlyNPCs;
};


#endif

