/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2007 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Fabian 'x3n' Landau
   co-programmer:
*/

#include "util/loading/load_param.h"
#include "util/loading/factory.h"
#include "mover_trigger_key.h"

ObjectListDefinition(KeyTrigger);
CREATE_FACTORY(KeyTrigger);


KeyTrigger::KeyTrigger(const TiXmlElement* root)
{
    this->registerObject(this, KeyTrigger::_objectList);
    this->toList(OM_ENVIRON);
    this->keyName = "";

    if (root != NULL)
        this->loadParams(root);

    this->init_post_params();
}

void KeyTrigger::loadParams(const TiXmlElement* root)
{
    MoverTrigger::loadParams(root);

    LoadParam(root, "key", this, KeyTrigger, setKey)
        .describe("The key that releases the trigger")
        .defaultValues("");
}

bool KeyTrigger::checkIsTriggered()
{
    /* TODO */
    return false;
}
