/*!
 * @file mover_trigger_key.h
 *  Gets triggered when player presses a key.
 */

#ifndef _MOVER_TRIGGER_KEY_H
#define _MOVER_TRIGGER_KEY_H

#include "mover_trigger.h"


class KeyTrigger : public MoverTrigger
{
    ObjectListDeclaration(KeyTrigger);

    public:
        KeyTrigger(const TiXmlElement* root = NULL);
        virtual void loadParams(const TiXmlElement* root);
        void setKey(const std::string& keyName) { this->keyName = keyName; }

    private:
        virtual bool checkIsTriggered();
        std::string keyName;
};


#endif

