/*!
 * @file mover_trigger_list.h
 *  A list to store and handle several triggers.
 */

#ifndef _MOVER_TRIGGER_LIST_H
#define _MOVER_TRIGGER_LIST_H

#include "mover_trigger.h"


class MoverTrigger;

class MoverTriggerListElement
{
    public:
        MoverTriggerListElement(MoverTrigger *trigger);
        ~MoverTriggerListElement();
        
        MoverTrigger *trigger;
        MoverTriggerListElement *next;
};


class MoverTriggerList
{
    public:
        MoverTriggerList();
        ~MoverTriggerList();

        void addTrigger(MoverTrigger *trigger);
        bool isTriggered();
        void setBaseCoor(Vector baseCoor);

    private:
        MoverTriggerListElement *first;
};


#endif
