/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2007 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Fabian 'x3n' Landau
   co-programmer:
*/

#include "util/loading/load_param.h"
#include "util/loading/factory.h"
#include "mover_trigger_mapstart.h"
#include "debug.h"

ObjectListDefinition(MapstartTrigger);
CREATE_FACTORY(MapstartTrigger);


MapstartTrigger::MapstartTrigger(const TiXmlElement* root)
{
    PRINTF(0)("13_1 MapstartTrigger %p created\n", this);
    this->registerObject(this, MapstartTrigger::_objectList);
    this->toList(OM_ENVIRON);

    this->bInit = true;

    if (root != NULL)
        this->loadParams(root);

    this->init_post_params();
}

void MapstartTrigger::loadParams(const TiXmlElement* root)
{
    MoverTrigger::loadParams(root);
}

bool MapstartTrigger::checkIsTriggered()
{
    if (this->bInit)
    {
        this->bInit = false;
        return true;
    }
    
    return false;
}
