/*!
 * @file mover_trigger_pointer_list.h
 *  A list to store and handle several trigger pointers.
 */

#ifndef _MOVER_TRIGGER_POINTER_LIST_H
#define _MOVER_TRIGGER_POINTER_LIST_H

#include "mover_trigger.h"


class MoverTrigger;

class MoverTriggerPointerListElement
{
    public:
        MoverTriggerPointerListElement(MoverTrigger *trigger);
        ~MoverTriggerPointerListElement();
        
        MoverTrigger *trigger;
        MoverTriggerPointerListElement *next;
};


class MoverTriggerPointerList
{
    public:
        MoverTriggerPointerList();
        ~MoverTriggerPointerList();

        void addTrigger(MoverTrigger *trigger);
        bool isTriggered();

    private:
        MoverTriggerPointerListElement *first;
};


#endif
